<template>
  <v-dialog
    width="50%"
    height="auto"
    v-model="selectedValue"
    name="create_client_receipt"
  >
    <v-card>
      <v-card-title class="light">Krijo një mandat</v-card-title>
      <v-container>
        <v-row class="mx-2">
          <v-col cols="12">
            <v-select
              label="Arka / Banka *"
              v-model="request.cash_unit_id"
              :items="banks"
              item-text="unit_name"
              item-value="id"
            />
          </v-col>
        </v-row>
        <v-row class="mx-2">
          <v-col cols="12">
            <v-select
              label="Lloji*"
              v-model="request.document_type"
              :items="documentTypes"
              required
              :rules="rules.document_type"
            />
          </v-col>
          <v-col cols="12">
            <v-text-field label="Data*" type="date" v-model="request.date" />
          </v-col>
          <v-col cols="12">
            <v-text-field
              label="Vlera*"
              v-model="request.value"
              type="number"
              min="0"
            />
          </v-col>
          <v-row class="mx-2">
            <v-col cols="6">
              <v-select
                label="Monedha"
                v-model="request.currency_id"
                :items="currencies"
                item-value="id"
                item-text="currency"
                @change="getExchangeRate"
              />
            </v-col>
            <v-col cols="6">
              <v-text-field label="Kursi" v-model="request.exchange_rate" />
            </v-col>
          </v-row>
          <v-col cols="12">
            <v-text-field label="Shënime*" v-model="request.notes" />
          </v-col>
        </v-row>
      </v-container>
      <v-card-actions>
        <f-confirm-btn
          label="Konfirmo kredit"
          @click="confirm"
          :disabled="loading"
        />
        <v-spacer />
        <f-cancel-btn @click="close" />
        <f-submit-btn @click="submit" :loading="loading" :disabled="loading" />
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>
<script lang="ts">
import Vue from 'vue'
import api from '../../../../plugins/api'
import { Component, Prop } from 'vue-property-decorator'
import eventBus from '../../../../plugins/event-bus'
import FSubmitBtn from '../../../../components/buttons/FSubmitBtn.vue'
import FCancelBtn from '../../../../components/buttons/FCancelBtn.vue'
import FConfirmBtn from '../../../../components/buttons/FConfirmBtn.vue'

@Component({
  components: { FSubmitBtn, FCancelBtn, FConfirmBtn },
})
export default class CreateClientReceipt extends Vue {
  @Prop({ required: true }) value

  request = {
    creditable_id: this.$route.params.id,
    creditable_type: 'App\\Client',
    document_type: '',
    date: '',
    value: '',
    currency_id: '',
    exchange_rate: '',
    notes: '',
    cash_unit_id: '',
    status_id: 0,
  }
  loading = false
  currencies = []
  banks = []
  documentTypes = ['MA', 'MAB', 'MAC']
  rules = {
    document_type: [v => !!v || 'Lloji duhet te zgjidhet '],
  }
  get selectedValue() {
    return this.value
  }
  set selectedValue(newValue) {
    this.$emit('input', newValue)
  }
  mounted() {
    this.fetchCurrencies()
    this.fetchBanks()
  }
  close() {
    this.selectedValue = false
    this.request.document_type = ''
    this.request.date = ''
    this.request.value = ''
    this.request.currency_id = ''
    this.request.exchange_rate = ''
    this.request.notes = ''
    this.request.cash_unit_id = ''
  }
  fetchBanks() {
    api()
      .get('/api/account-management/banks')
      .then(response => {
        this.banks = response.data.data
      })
      .finally(() => (this.loading = false))
  }
  fetchCurrencies() {
    api()
      .get('api/sales-management/checkout-info')
      .then(response => {
        this.currencies = response.data.data.currencies
      })
  }
  getExchangeRate() {
    this.request.exchange_rate = this.currencies.find(
      currency => currency.id === this.request.currency_id
    ).official_sell_rate
  }
  submit() {
    this.loading = true
    api()
      .post('api/account-management/receipts', this.request)
      .then(response => {
        alert(response.data.message)
        if (!(response && response.data && response.data.status === 0)) return
        this.close()
        eventBus.$emit('refresh')
      })
      .finally(() => {
        this.loading = false
      })
  }
  confirm() {
    this.request.status_id = 16
    this.submit()
  }
}
</script>
